## org.eclipse.emf.codegen.ecore.genmodel
Interface GenFeature

All Superinterfaces:
  EObject, GenBase, GenTypedElement, Notifier

All Known Implementing Classes:
  GenFeatureImpl

    public interface GenFeature

extends GenTypedElement

A representation of the model object 'Gen Feature'.

The following features are supported:

- `Property`
- `Notify`
- `Children`
- `Create Child`
- `Property Category`
- `Property Filter Flags`
- `Property Description`
- `Property Multi Line`
- `Property Sort Choices`
- `Gen Class`
- `Ecore Feature`

See Also:
  `GenModelPackage.getGenFeature()`

Method Summary
`java.lang.String` `getAccessorName()`
`java.lang.String` `getCapName()`
`java.lang.String` `getChangeableFlag()`
`java.lang.String` `getContainerClass()`
`java.lang.String` `getContainmentFlag()`
`java.lang.String` `getCreateChildValueLiteral()`
`java.lang.String` `getDefaultValue()`
`java.util.List<GenFeature>` `getDelegatedFeatures()`
`java.util.List<GenFeature>` `getDelegatedFeatures(GenModel genModel)`
`GenFeature` `getDelegateFeature()`
`java.lang.String` `getDerivedFlag()`
`EStructuralFeature` `getEcoreFeature()` Returns the value of the 'Ecore Feature' reference
`java.lang.String` `getEDefault()`
`java.lang.String` `getFeatureAccessorName()`
`java.lang.String` `getFeatureKind()`
`java.lang.String` `getFormattedName()`
`GenClass` `getGenClass()` Returns the value of the 'Gen Class' container reference.
`GenPackage` `getGenPackage()`
`java.lang.String` `getGetAccessor()`
`java.lang.String` `getGetArrayAccessor()`
`java.lang.String` `getIDFlag()`
`java.lang.String` `getImportedMetaType()`
`java.lang.String` `getIsName()`
`java.util.List<GenFeature>` `getKeys()`
`java.lang.String` `getMetaType()`
`java.lang.String` `getModelInfo()`
`java.lang.String` `getName()`
`GenPropertyKind` `getProperty()` Returns the value of the 'Property' attribute.
`java.lang.String` `getPropertyCategory()` Returns the value of the 'Property Category' attribute
`java.lang.String` `getPropertyDescription()` Returns the value of the 'Property Description' attribute
`EList<java.lang.String>` `getPropertyFilterFlags()` Returns the value of the 'Property Filter Flags' attribute list.
`java.lang.String` `getPropertyImageName()`
`java.lang.String` `getQualifiedFeatureAccessor()`
`java.lang.String` `getQualifiedFeatureAccessorName()`
`java.lang.String` `getQualifiedModelInfo()`
`java.lang.String` `getResolveProxiesFlag()`
`GenFeature` `getReverse()`
`java.lang.String` `getSafeName()`
`java.lang.String` `getSafeNameAsEObject()`
`java.lang.String` `getStaticDefaultValue()`
`java.lang.String` `getTransientFlag()`
`java.lang.String` `getUncapName()`
`java.lang.String` `getUnsettableFlag()`
`java.lang.String` `getUpperName()`
`java.lang.String` `getVolatileFlag()`
`boolean` `hasDelegateFeature()`
`boolean` `hasEDefault()`
`void` `initialize(EStructuralFeature eFeature)`
`boolean` `isBasicGet()`
`boolean` `isBasicSet()`
`boolean` `isBasicUnset()`
`boolean` `isBidirectional()`
`boolean` `isChangeable()`
`boolean` `isChildren()` Returns the value of the 'Children' attribute
`boolean` `isContainer()`
`boolean` `isContains()`
`boolean` `isCreateChild()` Returns the value of the 'Create Child' attribute
`boolean` `isDerived()`
`boolean` `isEffectiveContains()`
`boolean` `isESetField()`
`boolean` `isESetFlag()`
`boolean` `isField()`
`boolean` `isFlag()` Deprecated. use `GenClass.isFlag(org.eclipse.emf.codegen.ecore.genmodel.GenFeature)` to correctly determine whether a feature is a flag
`boolean` `isGet()`
`boolean` `isID()`
`boolean` `isIsSet()`
`boolean` `isNotify()` Returns the value of the 'Notify' attribute.
`boolean` `isProperty()`
`boolean` `isPropertyMultiLine()` Returns the value of the 'Property Multi Line' attribute
`boolean` `isPropertySortChoices()` Returns the value of the 'Property Sort Choices' attribute
`boolean` `isReferenceType()`
`boolean` `isResolveProxies()`
`boolean` `isSet()`
`boolean` `isSetCreateChild()` Returns whether the value of the '`Create Child`' attribute is set
`boolean` `isSetDefaultValue()`
`boolean` `isSuppressedGetVisibility()`
`boolean` `isSuppressedIsSetVisibility()`
`boolean` `isSuppressedSetVisibility()`
`boolean` `isSuppressedUnsetVisibility()`
`boolean` `isTested()` Returns whether the test case will test this feature.
`boolean` `isUnset()`
`boolean` `isUnsettable()`
`boolean` `isVolatile()`
`boolean` `reconcile(GenFeature oldGenFeatureVersion)`
`void` `setChildren(boolean value)` Sets the value of the '`Children`' attribute
`void` `setCreateChild(boolean value)` Sets the value of the '`Create Child`' attribute
`void` `setEcoreFeature(EStructuralFeature value)` Sets the value of the '`Ecore Feature`' reference
`void` `setGenClass(GenClass value)` Sets the value of the '`Gen Class`' container reference
`void` `setNotify(boolean value)` Sets the value of the '`Notify`' attribute
`void` `setProperty(GenPropertyKind value)` Sets the value of the '`Property`' attribute
`void` `setPropertyCategory(java.lang.String value)` Sets the value of the '`Property Category`' attribute
`void` `setPropertyDescription(java.lang.String value)` Sets the value of the '`Property Description`' attribute
`void` `setPropertyMultiLine(boolean value)` Sets the value of the '`Property Multi Line`' attribute
`void` `setPropertySortChoices(boolean value)` Sets the value of the '`Property Sort Choices`' attribute
`void` `unsetCreateChild()` Unsets the value of the '`Create Child`' attribute

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenTypedElement

`getEcoreModelElement, getEffectiveComplianceLevel, getEObjectCast, getGenClassType, getGenDataTypeType, getGenEnumType, getImportedEffectiveFeatureMapWrapperClass, getImportedEffectiveFeatureMapWrapperInternalInterface, getImportedInternalType, getImportedInternalType, getImportedMapEntryType, getImportedMapKeyType, getImportedMapTemplateArguments, getImportedMapValueType, getImportedType, getImportedType, getInternalTypeCast, getListItemType, getListItemType, getListTemplateArguments, getLowerBound, getMapEntryTypeGenClass, getMapGenClass, getMapItemType, getNonEObjectInternalTypeCast, getNonEObjectInternalTypeCast, getObjectType, getObjectType, getOrderedFlag, getPrimitiveValueFunction, getQualifiedListItemType, getQualifiedListItemType, getRawBoundType, getRawImportedBoundType, getRawImportedType, getRawListItemType, getRawType, getRawTypeCast, getType, getType, getTypeClassifier, getTypeClassifierAccessorName, getTypeGenClass, getTypeGenClassifier, getTypeGenDataType, getTypeGenEnum, getTypeGenPackage, getUniqueFlag, getUpperBound, hasGenericType, isBooleanType, isEffectiveSuppressEMFTypes, isEnumBasedType, isEnumType, isFeatureMapType, isFeatureMapWrapped, isListDataType, isListType, isMapType, isPrimitiveType, isStringBasedType, isStringType, isUncheckedCast, isUncheckedCast, isUnique, isWrappedFeatureMapType`

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenBase

`canGenerate, canGenerateEdit, canGenerateEditor, canGenerateSchema, canGenerateTests, capName, format, gen, genEdit, genEditor, generate, generate, generateEdit, generateEdit, generateEditor, generateEditor, generateSchema, generateSchema, generateTests, generateTests, genSchema, genTests, getCopyright, getDocumentation, getGenAnnotation, getGenAnnotations, getGenModel, hasCopyright, hasDocumentation, reconcile, safeName, uncapName, uncapPrefixedName`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Method Detail

### getProperty

    GenPropertyKind getProperty()

  Returns the value of the 'Property' attribute. The literals are from the enumeration `GenPropertyKind`.

  Returns:
    the value of the 'Property' attribute.
  See Also:
    `GenPropertyKind`, `setProperty(GenPropertyKind)`, `GenModelPackage.getGenFeature_Property()`

### setProperty

    void setProperty(GenPropertyKind value)

  Sets the value of the '`Property`' attribute.

  Parameters:
    `value` - the new value of the 'Property' attribute.
  See Also:
    `GenPropertyKind`, `getProperty()`

### isNotify

    boolean isNotify()

  Returns the value of the 'Notify' attribute. The default value is `"true"`.

  Returns:
    the value of the 'Notify' attribute.
  See Also:
    `setNotify(boolean)`, `GenModelPackage.getGenFeature_Notify()`

### setNotify

    void setNotify(boolean value)

  Sets the value of the '`Notify`' attribute.

  Parameters:
    `value` - the new value of the 'Notify' attribute.
  See Also:
    `isNotify()`

### isChildren

    boolean isChildren()

  Returns the value of the 'Children' attribute.

  Returns:
    the value of the 'Children' attribute.
  See Also:
    `setChildren(boolean)`, `GenModelPackage.getGenFeature_Children()`

### setChildren

    void setChildren(boolean value)

  Sets the value of the '`Children`' attribute.

  Parameters:
    `value` - the new value of the 'Children' attribute.
  See Also:
    `isChildren()`

### isCreateChild

    boolean isCreateChild()

  Returns the value of the 'Create Child' attribute.

  This attribute determines whether child objects can be created via this feature. It is temporarily unsettable to ease migration from pre-2.0 versions of EMF, in which the `children` feature did this as a secondary role.

  If the feature has not yet been set, it will be set based on the value of the `children` feature, before its value is returned. This ensures that pre-2.0 models will upgrade themselves, and continue to work as before.

  Returns:
    the value of the 'Create Child' attribute.
  See Also:
    `isSetCreateChild()`, `unsetCreateChild()`, `setCreateChild(boolean)`, `GenModelPackage.getGenFeature_CreateChild()`

### setCreateChild

    void setCreateChild(boolean value)

  Sets the value of the '`Create Child`' attribute.

  Parameters:
    `value` - the new value of the 'Create Child' attribute.
  See Also:
    `isSetCreateChild()`, `unsetCreateChild()`, `isCreateChild()`

### unsetCreateChild

    void unsetCreateChild()

  Unsets the value of the '`Create Child`' attribute.

  See Also:
    `isSetCreateChild()`, `isCreateChild()`, `setCreateChild(boolean)`

### isSetCreateChild

    boolean isSetCreateChild()

  Returns whether the value of the '`Create Child`' attribute is set.

  This always returns true. If the feature is unset, it will first be set based on the value of `children`. This ensures that pre-2.0 models will upgrade themselves, and continue to behave as before

  Returns:
    whether the value of the 'Create Child' attribute is set.
  See Also:
    `unsetCreateChild()`, `isCreateChild()`, `setCreateChild(boolean)`

### getPropertyCategory

    java.lang.String getPropertyCategory()

  Returns the value of the 'Property Category' attribute.

  Returns:
    the value of the 'Property Category' attribute.
  See Also:
    `setPropertyCategory(String)`, `GenModelPackage.getGenFeature_PropertyCategory()`

### setPropertyCategory

    void setPropertyCategory(java.lang.String value)

  Sets the value of the '`Property Category`' attribute.

  Parameters:
    `value` - the new value of the 'Property Category' attribute.
  See Also:
    `getPropertyCategory()`

### getPropertyFilterFlags

    EList<java.lang.String> getPropertyFilterFlags()

  Returns the value of the 'Property Filter Flags' attribute list. The list contents are of type `String`.

  Returns:
    the value of the 'Property Filter Flags' attribute list.
  See Also:
    `GenModelPackage.getGenFeature_PropertyFilterFlags()`

### getPropertyDescription

    java.lang.String getPropertyDescription()

  Returns the value of the 'Property Description' attribute.

  Returns:
    the value of the 'Property Description' attribute.
  See Also:
    `setPropertyDescription(String)`, `GenModelPackage.getGenFeature_PropertyDescription()`

### setPropertyDescription

    void setPropertyDescription(java.lang.String value)

  Sets the value of the '`Property Description`' attribute.

  Parameters:
    `value` - the new value of the 'Property Description' attribute.
  See Also:
    `getPropertyDescription()`

### isPropertyMultiLine

    boolean isPropertyMultiLine()

  Returns the value of the 'Property Multi Line' attribute.

  Returns:
    the value of the 'Property Multi Line' attribute.
  See Also:
    `setPropertyMultiLine(boolean)`, `GenModelPackage.getGenFeature_PropertyMultiLine()`

### setPropertyMultiLine

    void setPropertyMultiLine(boolean value)

  Sets the value of the '`Property Multi Line`' attribute.

  Parameters:
    `value` - the new value of the 'Property Multi Line' attribute.
  See Also:
    `isPropertyMultiLine()`

### isPropertySortChoices

    boolean isPropertySortChoices()

  Returns the value of the 'Property Sort Choices' attribute.

  Returns:
    the value of the 'Property Sort Choices' attribute.
  See Also:
    `setPropertySortChoices(boolean)`, `GenModelPackage.getGenFeature_PropertySortChoices()`

### setPropertySortChoices

    void setPropertySortChoices(boolean value)

  Sets the value of the '`Property Sort Choices`' attribute.

  Parameters:
    `value` - the new value of the 'Property Sort Choices' attribute.
  See Also:
    `isPropertySortChoices()`

### getGenClass

    GenClass getGenClass()

  Returns the value of the 'Gen Class' container reference. It is bidirectional and its opposite is '`Gen Features`'.

  Returns:
    the value of the 'Gen Class' container reference.
  See Also:
    `setGenClass(GenClass)`, `GenModelPackage.getGenFeature_GenClass()`, `GenClass.getGenFeatures()`

### setGenClass

    void setGenClass(GenClass value)

  Sets the value of the '`Gen Class`' container reference.

  Parameters:
    `value` - the new value of the 'Gen Class' container reference.
  See Also:
    `getGenClass()`

### getEcoreFeature

    EStructuralFeature getEcoreFeature()

  Returns the value of the 'Ecore Feature' reference.

  Returns:
    the value of the 'Ecore Feature' reference.
  See Also:
    `setEcoreFeature(EStructuralFeature)`, `GenModelPackage.getGenFeature_EcoreFeature()`

### setEcoreFeature

    void setEcoreFeature(EStructuralFeature value)

  Sets the value of the '`Ecore Feature`' reference.

  Parameters:
    `value` - the new value of the 'Ecore Feature' reference.
  See Also:
    `getEcoreFeature()`

### getName

    java.lang.String getName()

### getSafeName

    java.lang.String getSafeName()

### getSafeNameAsEObject

    java.lang.String getSafeNameAsEObject()

### getCapName

    java.lang.String getCapName()

### getUncapName

    java.lang.String getUncapName()

### getUpperName

    java.lang.String getUpperName()

### getFormattedName

    java.lang.String getFormattedName()

### getIsName

    java.lang.String getIsName()

### getAccessorName

    java.lang.String getAccessorName()

### getGetArrayAccessor

    java.lang.String getGetArrayAccessor()

### getGetAccessor

    java.lang.String getGetAccessor()

### getGenPackage

    GenPackage getGenPackage()

### getFeatureAccessorName

    java.lang.String getFeatureAccessorName()

### getQualifiedFeatureAccessorName

    java.lang.String getQualifiedFeatureAccessorName()

### getQualifiedFeatureAccessor

    java.lang.String getQualifiedFeatureAccessor()

### getMetaType

    java.lang.String getMetaType()

### getImportedMetaType

    java.lang.String getImportedMetaType()

### getFeatureKind

    java.lang.String getFeatureKind()

### isReferenceType

    boolean isReferenceType()

### isFlag

    @Deprecated
    boolean isFlag()

  Deprecated. use `GenClass.isFlag(org.eclipse.emf.codegen.ecore.genmodel.GenFeature)` to correctly determine whether a feature is a flag

  This method isn't terribly useful now that an enum attribute could be considered a flag, but should only be generated as such if `packed enums` is enabled for the model. This method still returns false in that case.

### isESetFlag

    boolean isESetFlag()

### isSetDefaultValue

    boolean isSetDefaultValue()

### getDefaultValue

    java.lang.String getDefaultValue()

### getStaticDefaultValue

    java.lang.String getStaticDefaultValue()

### isContainer

    boolean isContainer()

### isContains

    boolean isContains()

### isEffectiveContains

    boolean isEffectiveContains()

### isBidirectional

    boolean isBidirectional()

### getReverse

    GenFeature getReverse()

### getKeys

    java.util.List<GenFeature> getKeys()

### getContainerClass

    java.lang.String getContainerClass()

### getDerivedFlag

    java.lang.String getDerivedFlag()

### getTransientFlag

    java.lang.String getTransientFlag()

### getVolatileFlag

    java.lang.String getVolatileFlag()

### getChangeableFlag

    java.lang.String getChangeableFlag()

### getUnsettableFlag

    java.lang.String getUnsettableFlag()

### getIDFlag

    java.lang.String getIDFlag()

### getContainmentFlag

    java.lang.String getContainmentFlag()

### getResolveProxiesFlag

    java.lang.String getResolveProxiesFlag()

### isVolatile

    boolean isVolatile()

### isChangeable

    boolean isChangeable()

### isUnsettable

    boolean isUnsettable()

### isID

    boolean isID()

### isDerived

    boolean isDerived()

### isResolveProxies

    boolean isResolveProxies()

### hasDelegateFeature

    boolean hasDelegateFeature()

### getDelegateFeature

    GenFeature getDelegateFeature()

### getDelegatedFeatures

    java.util.List<GenFeature> getDelegatedFeatures()

### getDelegatedFeatures

    java.util.List<GenFeature> getDelegatedFeatures(GenModel genModel)

  Since:
    2.4

### getCreateChildValueLiteral

    java.lang.String getCreateChildValueLiteral()

### isSuppressedGetVisibility

    boolean isSuppressedGetVisibility()

### isSuppressedSetVisibility

    boolean isSuppressedSetVisibility()

### isSuppressedIsSetVisibility

    boolean isSuppressedIsSetVisibility()

### isSuppressedUnsetVisibility

    boolean isSuppressedUnsetVisibility()

### initialize

    void initialize(EStructuralFeature eFeature)

### getPropertyImageName

    java.lang.String getPropertyImageName()

### getModelInfo

    java.lang.String getModelInfo()

### getQualifiedModelInfo

    java.lang.String getQualifiedModelInfo()

### isProperty

    boolean isProperty()

### reconcile

    boolean reconcile(GenFeature oldGenFeatureVersion)

### isField

    boolean isField()

### isESetField

    boolean isESetField()

### isGet

    boolean isGet()

### isBasicGet

    boolean isBasicGet()

### isBasicSet

    boolean isBasicSet()

### isSet

    boolean isSet()

### isBasicUnset

    boolean isBasicUnset()

### isUnset

    boolean isUnset()

### isIsSet

    boolean isIsSet()

### hasEDefault

    boolean hasEDefault()

  Since:
    2.3

### getEDefault

    java.lang.String getEDefault()

  Since:
    2.3

### isTested

    boolean isTested()

  Returns whether the test case will test this feature.

  Since:
    2.3

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.